Public Class frmBarcode29
    Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "

    Public Sub New()
        MyBase.New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen

    End Sub

    ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Fr Windows Form-Designer erforderlich
    Private components As System.ComponentModel.IContainer

    'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
    'Sie kann mit dem Windows Form-Designer modifiziert werden.
    'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
  Friend WithEvents txtString As System.Windows.Forms.TextBox
  Friend WithEvents pnlCode As System.Windows.Forms.Panel
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
Me.txtString = New System.Windows.Forms.TextBox()
Me.pnlCode = New System.Windows.Forms.Panel()
Me.SuspendLayout()
'
'txtString
'
Me.txtString.Location = New System.Drawing.Point(16, 8)
Me.txtString.Name = "txtString"
Me.txtString.Size = New System.Drawing.Size(256, 20)
Me.txtString.TabIndex = 0
Me.txtString.Text = "ActiveVB"
'
'pnlCode
'
Me.pnlCode.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.pnlCode.Location = New System.Drawing.Point(8, 40)
Me.pnlCode.Name = "pnlCode"
Me.pnlCode.Size = New System.Drawing.Size(272, 40)
Me.pnlCode.TabIndex = 1
'
'frmBarcode29
'
Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
Me.ClientSize = New System.Drawing.Size(292, 94)
Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.pnlCode, Me.txtString})
Me.Name = "frmBarcode29"
Me.Text = "Barcode39"
Me.ResumeLayout(False)

    End Sub

#End Region

    Private Function MD_Barcode39(ByVal Barcode As String, _
        ByVal PaintObj As Object, _
        ByVal mLeft As Single, _
        ByVal mTop As Single, _
        ByVal mWidth As Single, _
        ByVal mHeight As Single)

        Const Nratio = 20, Wratio = 55, Qratio = 35

        Dim Nbar As Single, Wbar As Single, Qbar As Single, NextBar As Single
        Dim CountX As Single, CountY As Single, CountR As Single
        Dim Parts As Single, Pix As Single, BarCodePlus As String
        Dim Stripes As String, BarType As String
        Dim Mx As Single, [My] As Single, Sx As Single, Sy As Single

        Dim g As System.Drawing.Graphics
        Dim pB As New System.Drawing.SolidBrush(System.Drawing.Color.Black)
        Dim pW As New System.Drawing.SolidBrush(System.Drawing.Color.White)
        Dim color As System.Drawing.SolidBrush

        Try
            ' Get control size and location properties.
            Sx = mLeft
            Sy = mTop
            Mx = mWidth
            [My] = mHeight

            g = PaintObj.CreateGraphics()

            ' Calculate actual and relative pixels values.
            Parts = (Barcode.Length + 2) * _
                ((6 * Nratio) + (3 * Wratio) + (1 * Qratio))
            Pix = (Mx / Parts)
            Nbar = (20 * Pix) : Wbar = (55 * Pix) : Qbar = (35 * Pix)

            ' Initialize bar index and color.
            NextBar = Sx
            color = pW

            ' Pad each end of string with start/stop characters.
            BarCodePlus = "*" & Barcode.ToUpper & "*"

            ' Walk through each character of the barcode contents.
            For CountX = 0 To BarCodePlus.Length - 1
                ' Get Barcode 1/0 string for indexed character.
                Stripes = MD_BC39(BarCodePlus.Substring(CountX, 1))
                For CountY = 0 To 8
                    ' For each 1/0, draw a wide/narrow bar.
                    BarType = Stripes.Substring(CountY, 1)

                    'Toggle the color (black/white).
                    If color Is pW Then
                        color = pB
                    Else
                        color = pW
                    End If

                    Select Case BarType
                    Case "1"
                        ' Draw a wide bar.
                        g.FillRectangle(color, NextBar, Sy, _
                            Wbar + NextBar, [My] + Sy)
                        NextBar = NextBar + Wbar
                    Case "0"
                        ' Draw a narrow bar.
                        g.FillRectangle(color, NextBar, Sy, _
                            Nbar + NextBar, [My] + Sy)
                        NextBar = NextBar + Nbar
                    End Select
                Next CountY

                ' Toggle the color (black/white).
                If color Is pW Then
                    color = pB
                Else
                    color = pW
                End If

                ' Draw intermediate "quiet" bar.
                g.FillRectangle(color, NextBar, Sy, Qbar + NextBar, [My] + Sy)
                NextBar = NextBar + Qbar
            Next CountX
        Catch ex As Exception
            MessageBox.Show(ex.StackTrace)
        End Try
    End Function

    Function MD_BC39(ByVal CharCode As String) As String
        Try
            Dim BC39(90) As String

            BC39(32) = "011000100" ' space
            BC39(36) = "010101000" ' $
            BC39(37) = "000101010" ' %
            BC39(42) = "010010100" ' * Start/Stop
            BC39(43) = "010001010" ' +
            BC39(45) = "010000101" ' |
            BC39(46) = "110000100" ' .
            BC39(47) = "010100010" ' /
            BC39(48) = "000110100" ' 0
            BC39(49) = "100100001" ' 1
            BC39(50) = "001100001" ' 2
            BC39(51) = "101100000" ' 3
            BC39(52) = "000110001" ' 4
            BC39(53) = "100110000" ' 5
            BC39(54) = "001110000" ' 6
            BC39(55) = "000100101" ' 7
            BC39(56) = "100100100" ' 8
            BC39(57) = "001100100" ' 9
            BC39(65) = "100001001" ' A
            BC39(66) = "001001001" ' B
            BC39(67) = "101001000" ' C
            BC39(68) = "000011001" ' D
            BC39(69) = "100011000" ' E
            BC39(70) = "001011000" ' F
            BC39(71) = "000001101" ' G
            BC39(72) = "100001100" ' H
            BC39(73) = "001001100" ' I
            BC39(74) = "000011100" ' J
            BC39(75) = "100000011" ' K
            BC39(76) = "001000011" ' L
            BC39(77) = "101000010" ' M
            BC39(78) = "000010011" ' N
            BC39(79) = "100010010" ' O
            BC39(80) = "001010010" ' P
            BC39(81) = "000000111" ' Q
            BC39(82) = "100000110" ' R
            BC39(83) = "001000110" ' S
            BC39(84) = "000010110" ' T
            BC39(85) = "110000001" ' U
            BC39(86) = "011000001" ' V
            BC39(87) = "111000000" ' W
            BC39(88) = "010010001" ' X
            BC39(89) = "110010000" ' Y
            BC39(90) = "011010000" ' Z

            Return BC39(Asc(CharCode))
        Catch ex As Exception
            Return ""
        End Try
    End Function

    Private Sub txtString_TextChanged(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles txtString.TextChanged

        pnlCode.Refresh()
    End Sub

    Private Sub pnlCode_Paint(ByVal sender As Object, _
        ByVal e As System.Windows.Forms.PaintEventArgs) Handles pnlCode.Paint

        MD_Barcode39(txtString.Text, pnlCode, 0, 0, _
            pnlCode.Size.Width, pnlCode.Size.Height)
    End Sub
End Class
